//--------------------------------------//
// MoreBlood  2010 - Mr.Loathsome       //
// Players bleed where they take damage //
// Based on the Bleeder mutator         //
//--------------------------------------//
class MB expands Mutator;

var bool bRandomMode;
var bool bExcessiveMode;
var bool bDebugMode;
var bool bDeathEffect;
var int  MaxBleeders;
var int  BleedTime;
var float BDLifeSpan;
var float BDDrawScale;
var float SpurtLevelx;
var float SpurtLevelz;
var int  MaxBleedersRV;
var int  BleedTimeRV;
var float BDLifeSpanRV;
var float BDDrawScaleRV;
var float SpurtLevelxRV;
var float SpurtLevelzRV;

var int  BleedLimiter;
var bool bInitialized;

function PostBeginPlay()
{
	if (bInitialized) return;
	else bInitialized = True;
	Level.Game.RegisterDamageMutator(Self);
	bRandomMode = class'MoreBloodConfig'.Default.bRandomMode;
	bExcessiveMode = class'MoreBloodConfig'.Default.bExcessiveMode;
	bDebugMode = class'MoreBloodConfig'.Default.bDebugMode;
	bDeathEffect = class'MoreBloodConfig'.Default.bDeathEffect;
	MaxBleeders = class'MoreBloodConfig'.Default.MaxBleeders;
	BleedTime = class'MoreBloodConfig'.Default.BleedTime;
	BDLifeSpan = class'MoreBloodConfig'.Default.BDLifeSpan;
	BDDrawScale = class'MoreBloodConfig'.Default.BDDrawScale;
	SpurtLevelx = class'MoreBloodConfig'.Default.SpurtLevelx;
	SpurtLevelz = class'MoreBloodConfig'.Default.SpurtLevelz;

	if (bRandomMode)
	{
		MaxBleedersRV = class'MoreBloodConfig'.Default.MaxBleedersRV - (class'MoreBloodConfig'.Default.MaxBleedersRV / 5);
		BleedTimeRV = class'MoreBloodConfig'.Default.BleedTimeRV - (class'MoreBloodConfig'.Default.BleedTimeRV / 5);
		BDLifeSpanRV = class'MoreBloodConfig'.Default.BDLifeSpanRV - (class'MoreBloodConfig'.Default.BDLifeSpanRV / 5);
		BDDrawScaleRV = class'MoreBloodConfig'.Default.BDDrawScaleRV - (class'MoreBloodConfig'.Default.BDDrawScaleRV / 5);
		SpurtLevelxRV = class'MoreBloodConfig'.Default.SpurtLevelxRV - (class'MoreBloodConfig'.Default.SpurtLevelxRV / 5);
		SpurtLevelzRV = class'MoreBloodConfig'.Default.SpurtLevelzRV - (class'MoreBloodConfig'.Default.SpurtLevelzRV / 5);

		MaxBleeders = Rand(MaxBleedersRV) + 1;
		BleedTime = Rand(BleedTimeRV) + ((BleedTimeRV / 5) + 1);
		BDLifeSpan = (FRand() * BDLifeSpanRV) + (BDLifeSpanRV / 5) + 0.0125;
		BDDrawScale = (FRand() * BDDrawScaleRV) + (BDDrawScaleRV / 5) + 0.00125;
		SpurtLevelx = Rand(SpurtLevelxRV) + (SpurtLevelxRV / 5);
		SpurtLevelz = Rand(SpurtLevelzRV) + (SpurtLevelzRV / 5);
		if (MaxBleeders > 80) MaxBleeders = 80;
		if (BleedTime > 255) BleedTime = 255;
		if (BDLifeSpan > 255) BDLifeSpan = 255;
		if (BDDrawScale > 1) BDDrawScale = 1;
		class'MoreBloodConfig'.Default.MaxBleeders = MaxBleeders;
		class'MoreBloodConfig'.Default.BleedTime = BleedTime;
		class'MoreBloodConfig'.Default.BDLifeSpan = BDLifeSpan;
		class'MoreBloodConfig'.Default.BDDrawScale = BDDrawScale;
		class'MoreBloodConfig'.Default.SpurtLevelx = SpurtLevelx;
		class'MoreBloodConfig'.Default.SpurtLevelz = SpurtLevelz;
		class'MoreBloodConfig'.static.StaticSaveConfig();				
	}
	else
	{
		if (MaxBleeders > 80) MaxBleeders = 80;
		if (BleedTime > 255) BleedTime = 255;
		if (BDLifeSpan > 255) BDLifeSpan = 255;
		if (BDDrawScale > 1) BDDrawScale = 1;
	}
	if (bExcessiveMode)
		BleedLimiter = 2;
	else
		BleedLimiter = 10;
	if (bDebugMode)
		log("MaxBleeders = "$MaxBleeders$"  BleedTime = "$BleedTime$"  BDLifeSpan = "$BDLifeSpan$"  BDDrawScale = "$BDDrawScale$"  SpurtLevelx = "$SpurtLevelx$"  SpurtLevelz = "$SpurtLevelz);
	Super.PostBeginPlay();
}

function MutatorTakeDamage(out int ActualDamage, Pawn Victim, Pawn InstigatedBy, out Vector HitLocation, out Vector Momentum, name DamageType)
{
	BloodDamage(ActualDamage, Victim, HitLocation, Momentum, DamageType);
	Super.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);
}

function BloodDamage(int NDamage, Pawn Victim, Vector hitlocation, 
					Vector momentum, name damageType)

{
	local BleederEffectSpawner BES;
	local class<Effects> EffS;
	local int i, j, nb;

	if (NDamage > 0)
	{
	if ((Victim.Health - NDamage) <= 0)
		{
		 if ((bDeathEffect) && (NDamage < 30) && (Victim.bIsPlayer))
			DeathEffect(Victim);
		}
		else
		{
			nb = NumBleeders(Victim);
			if (bDebugMode)
				log(Victim$"  Health = "$Victim.health$"  defaultHealth = "$Victim.default.health$"   NumBleeders = "$nb$"   ActualDamage = "$NDamage);
			if (((bExcessiveMode) && (nb < MaxBleeders)) || ((nb < (((Victim.health) / BleedLimiter) + 1) && (nb < MaxBleeders))))
			{
				BES = Spawn(class'BleederEffectSpawner', Victim, , HitLocation, Victim.Rotation);
				if (BES != None)
				{
					j = (NDamage + BleedTime) * 2;
					BES.InitSpawner();
					if ((Victim.IsA('ScriptedPawn')) && (ScriptedPawn(Victim).bGreenBlood))
					{
						if (NDamage < 25)
						{
							if (Rand(16) == 8)
								EffS = class'UTB_GBloodDrop2';
							else
								EffS = class'UTB_GBloodDrop';
						}
						else
						if (NDamage < 35)
						{
							EffS = class'GreenBlob';
						}
						else
						if (NDamage < 65)
							EffS = class'GreenBloodPuff';
						else
							EffS = class'GreenBloodSpray';
					}
					else
					{
						if (NDamage < 15)
						{
							if (Rand(2) == 1)
								EffS = class'UTB_BloodDrop2';
							else
							if (Rand(2) == 1)
								EffS = class'UTB_BloodDrop3';
							else
								EffS = class'UTB_BloodDrop';
							j = j * 2;
						}
						else
						if (NDamage < 25)
						{
							if (Rand(2) == 1)
								EffS = class'UT_BloodHit';
							else
								EffS = class'BloodSpurt';
						}
						else
						if (NDamage < 40)
						{
							if (Rand(2) == 1)
								EffS = class'UTB_BloodDrop3';
							else
								EffS = class'BloodPuff';
						}
						else
						if (NDamage < 60)
						{
							EffS = class'UT_BigBloodHit';
						}
						else
							if (Rand(2) == 1)
								EffS = class'UTB_BloodDrop2';
							else
								EffS = class'BloodSpray';
					}
					BES.SetSpawnProperties(0.5, j, EffS, true);
					BES = None;
				}
			}
		}
	}
}

function int NumBleeders(Pawn Other)
{
	local BleederEffectSpawner BES;
	local int nb;

	nb = 0;
	foreach Other.ChildActors(class'BleederEffectSpawner', BES)
	{
		nb++;
	}
	return nb;
}

function DeathEffect(Pawn Other)
{
	local BleederEffectSpawner BES;
	local class<Effects> EffS;

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodDrop2';
	BES.SetSpawnProperties(0.5, 40, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodDrop3';
	BES.SetSpawnProperties(0.5, 25, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodDrop';
	BES.SetSpawnProperties(0.5, 12, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'BloodSpurt';
	BES.SetSpawnProperties(0.5, 6, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'BloodSpray';
	BES.SetSpawnProperties(0.5, 4, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Location, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodTrail';
	BES.SetSpawnProperties(0.5, 2, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Floor, Other.Rotation);
	BES.InitSpawner();
	EffS = class'UTB_BloodTrail';
	BES.SetSpawnProperties(0.5, 1, EffS, true);

	BES = Spawn(class'BleederEffectSpawner', Other, , Other.Floor, );
	BES.InitSpawner();
	EffS = class'UTB_BloodPool';
	BES.SetSpawnProperties(0.5, 1, EffS, true);
}

defaultproperties
{
	bRandomMode=False
	bExcessiveMode=False
	bDebugMode=False
	bDeathEffect=True
	MaxBleeders=5
	BleedTime=100
	BDLifeSpan=3.0
	BDDrawScale=0.25000
	SpurtLevelx=85
	SpurtLevelz=85
	MaxBleedersRV=15
	BleedTimeRV=145
	BDLifeSpanRV=3.0
	BDDrawScaleRV=0.25000
	SpurtLevelxRV=40
	SpurtLevelzRV=80
	BleedLimiter=10
	bHidden=True
}
