//=============================================================================
// MoreBloodConfig
//=============================================================================
class MoreBloodConfig expands UWindowDialogClientWindow config(MoreBlood);

var UWindowHSliderControl slider;
var UWindowHSliderControl slider2;
var UWindowHSliderControl slider3;
var UWindowHSliderControl slider4;
var UWindowHSliderControl slider5;
var UWindowHSliderControl slider6;
var UWindowCheckBox checkbox1;
var UWindowCheckBox checkbox2;
var UWindowCheckBox checkbox3;
var UWindowCheckBox checkbox4;
var UWindowCheckBox checkbox5;
var UWindowSmallButton CloseButton;
var UWindowSmallCloseButton CancelButton;
var UWindowEditControl adjbotEditBox;
var UWindowEditControl adjbotEditBox2;
var UWindowEditControl adjbotEditBox3;
var UWindowEditControl adjbotEditBox4;
var UWindowEditControl adjbotEditBox5;
var UWindowEditControl adjbotEditBox6;
var string L;
var bool bInit;

//MoreBlood setup variables
var() config bool bRandomMode;
var() config bool bExcessiveMode;
var() config bool bDebugMode;
var() config bool bDeathEffect;
var() config int  MaxBleeders;
var() config int  BleedTime;
var() config float BDLifeSpan;
var() config float BDDrawScale;
var() config float SpurtLevelx;
var() config float SpurtLevelz;
var() config int  MaxBleedersRV;
var() config int  BleedTimeRV;
var() config float BDLifeSpanRV;
var() config float BDDrawScaleRV;
var() config float SpurtLevelxRV;
var() config float SpurtLevelzRV;

function Created()
{	
	Super.Created();
	
	slider = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 20, 15, 350, 1));
	slider.SetText("Maximum Bleeders per Pawn: ");
	slider.SetRange(1,40,1);
	if (MaxBleeders > 40)
		slider.SetValue(40);
	else
		slider.SetValue(MaxBleeders);
	adjbotEditBox = UWindowEditControl(CreateWindow(class'UWindowEditControl', 20, 30, 350, WinHeight-30));
	adjbotEditBox.Align = TA_Left;
	adjbotEditBox.SetText("Recommended range: 2 - 8");
	adjbotEditBox.SetValue(Left(string(MaxBleeders), 3));
	adjbotEditBox.SetNumericOnly(False);
	adjbotEditBox.EditBoxWidth = 32;

	slider2 = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 20, 60, 350, 1));
	slider2.SetText("Duration of bleeding effects: ");
	slider2.SetRange(1,255,1);
	if (BleedTime > 255)
		slider2.SetValue(255);
	else
		slider2.SetValue(BleedTime);
	
	adjbotEditBox2 = UWindowEditControl(CreateWindow(class'UWindowEditControl', 20, 75, 350, WinHeight-30));
	adjbotEditBox2.Align = TA_Left;
	adjbotEditBox2.SetText("Recommended range: 10 - 80");
	adjbotEditBox2.SetValue(Left(string(BleedTime), 3));
	adjbotEditBox2.SetNumericOnly(True);
	adjbotEditBox2.EditBoxWidth = 32;

	slider3 = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 20, 105, 350, 1));
	slider3.SetText("BloodDrop effect lifepan: ");
	slider3.SetRange(0.0125,32,0.1);
	if (BDLifeSpan > 32)
		slider3.SetValue(32);
	else
		slider3.SetValue(BDLifeSpan);
	
	adjbotEditBox3 = UWindowEditControl(CreateWindow(class'UWindowEditControl', 20, 120, 350, WinHeight-30));
	adjbotEditBox3.Align = TA_Left;
	adjbotEditBox3.SetText("Recommended range: 5 - 20              *Drag to adjust by fractions");
	adjbotEditBox3.SetNumericOnly(False);
	adjbotEditBox3.EditBoxWidth = 32;
	adjbotEditBox3.SetValue(Left(string(BDLifeSpan), 4));

	slider4 = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 20, 150, 350, 1));
	slider4.SetText("BloodDrop draw scale: ");
	slider4.SetRange(0.0125,1.0,0.01);
	if (BDDrawScale > 1)
		slider4.SetValue(1);
	else
		slider4.SetValue(BDDrawScale);
	
	adjbotEditBox4 = UWindowEditControl(CreateWindow(class'UWindowEditControl', 20, 165, 350, WinHeight-30));
	adjbotEditBox4.Align = TA_Left;
	adjbotEditBox4.SetText("Recommended range: 0.025 - 0.40       *Drag slider to adjust");
	adjbotEditBox4.SetNumericOnly(False);
	adjbotEditBox4.EditBoxWidth = 32;
	adjbotEditBox4.SetValue(Left(string(BDDrawScale), 5));

	slider5 = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 20, 195, 350, 1));
	slider5.SetText("SpurtLevelx: (Distance)");
	slider5.SetRange(1,255,1);
	if (SpurtLevelx > 255)
		slider5.SetValue(255);
	else
		slider5.SetValue(SpurtLevelx);
	
	adjbotEditBox5 = UWindowEditControl(CreateWindow(class'UWindowEditControl', 20, 210, 350, WinHeight-30));
	adjbotEditBox5.Align = TA_Left;
	adjbotEditBox5.SetText("Recommended range: 5 - 80");
	adjbotEditBox5.SetValue(Left(string(SpurtLevelx), 3));
	adjbotEditBox5.SetNumericOnly(True);
	adjbotEditBox5.EditBoxWidth = 32;

	slider6 = UWindowHSliderControl(CreateControl(class'UWindowHSliderControl', 20, 240, 350, 1));
	slider6.SetText("SpurtLevelz: (Height)");
	slider6.SetRange(1,255,1);
	if (SpurtLevelz > 255)
		slider6.SetValue(255);
	else
		slider6.SetValue(SpurtLevelz);
	
	adjbotEditBox6 = UWindowEditControl(CreateWindow(class'UWindowEditControl', 20, 255, 350, WinHeight-30));
	adjbotEditBox6.Align = TA_Left;
	adjbotEditBox6.SetText("Recommended range: 5 - 80");
	adjbotEditBox6.SetValue(Left(string(SpurtLevelz), 3));
	adjbotEditBox6.SetNumericOnly(True);
	adjbotEditBox6.EditBoxWidth = 32;



	checkbox1 = UWindowCheckBox(CreateControl(class'UWindowCheckBox', 20, 300, 178, 1));
	checkbox1.SetText("Random Mode: ");
	checkbox1.bChecked = bRandomMode;

	checkbox2 = UWindowCheckBox(CreateControl(class'UWindowCheckBox', 20, 320, 178, 1));
	checkbox2.SetText("Excessive Mode: ");
	checkbox2.bChecked = bExcessiveMode;

	checkbox3 = UWindowCheckBox(CreateControl(class'UWindowCheckBox', 20, 340, 178, 1));
	checkbox3.SetText("Debug Mode: ");
	checkbox3.bChecked = bDebugMode;

	checkbox4 = UWindowCheckBox(CreateControl(class'UWindowCheckBox', 20, 360, 178, 1));
	checkbox4.SetText("Use DeathEffect: ");
	checkbox4.bChecked = bDeathEffect;

	// Update button 
	CloseButton = UWindowSmallButton(CreateWindow(class'UWindowSmallButton', 275 , 310, 48, 16));
	CloseButton.SetText( "Update" );
	CloseButton.NotifyWindow = Self; // doesn't seem to work otherwise.

	// Cancel button
	CancelButton = UWindowSmallCloseButton(CreateWindow(class'UWindowSmallCloseButton', 275, 350, 48, 16));
	CancelButton.SetText( "Cancel" );	
}

//when a control changes, Notify is called with the changed control
function Notify(UWindowDialogControl C, byte E)
{
	local float sval;
	local int sival;

	Super.Notify( C, E );

	if (checkbox1 != None)
	switch(E)
	{
	case DE_Change: // the message sent by sliders and checkboxes 
	switch(C)
	{	
		case slider:
			sival =  slider.GetValue(); sval = sival;
			adjbotEditBox.SetValue(Left(string(sival), 3));
			MaxBleeders = sval;
			break;		
		case slider2:
			sival =  slider2.GetValue(); sval = sival;
			adjbotEditBox2.SetValue(Left(string(sival), 3));
			BleedTime = sval;
			break;		
		case slider3:
			sval =  slider3.GetValue();
			BDLifeSpan = sval;
			adjbotEditBox3.SetValue(Left(string(BDLifeSpan), 4));
			break;		
		case slider4:
			sval =  slider4.GetValue();
			BDDrawScale = sval;
			adjbotEditBox4.SetValue(Left(string(BDDrawScale), 5));
			break;		
		case slider5:
			sval =  slider5.GetValue();
			SpurtLevelx = sval;
			adjbotEditBox5.SetValue(Left(string(SpurtLevelx), 3));
			break;		
		case slider6:
			sval =  slider6.GetValue();
			SpurtLevelz = sval;
			adjbotEditBox6.SetValue(Left(string(SpurtLevelz), 3));
			break;		
		case checkbox1:
			if (checkbox1.bChecked) 
				bRandomMode = True;
			else
				bRandomMode = False;
			break;						
		case checkbox2:
			if (checkbox2.bChecked) 
				bExcessiveMode = True;
			else
				bExcessiveMode = False;
			break;						
		case checkbox3:
			if (checkbox3.bChecked) 
				bDebugMode = True;
			else
				bDebugMode = False;
			break;						
		case checkbox4:
			if (checkbox4.bChecked) 
				bDeathEffect = True;
			else
				bDeathEffect = False;
			break;						
	}
	case DE_Click:
	switch(C)
		{		
			case CloseButton:
				sval = float(adjbotEditBox.GetValue());
				MaxBleeders = sval; MaxBleedersRV = sval;
				sval = float(adjbotEditBox2.GetValue());
				BleedTime = sval; BleedTimeRV = sval;
				sval = float(adjbotEditBox3.GetValue());
				BDLifeSpan = sval; BDLifeSpanRV = sval;
				sval = float(adjbotEditBox4.GetValue());
				BDDrawScale = sval; BDDrawScaleRV = sval;
				sval = float(adjbotEditBox5.GetValue());
				SpurtLevelx = sval; SpurtLevelxRV = sval;
				sval = float(adjbotEditBox6.GetValue());
				SpurtLevelz = sval; SpurtLevelzRV = sval;
				SaveConfig();
				ParentWindow.Close();
			break;
		}
	break;
	}
}

defaultproperties
{
	bRandomMode=False
	bExcessiveMode=False
	bDebugMode=False
	bDeathEffect=True
	MaxBleeders=5
	BleedTime=100
	BDLifeSpan=3.0
	BDDrawScale=0.25000
	SpurtLevelx=85
	SpurtLevelz=85
	MaxBleedersRV=15
	BleedTimeRV=145
	BDLifeSpanRV=3.0
	BDDrawScaleRV=0.25000
	SpurtLevelxRV=40
	SpurtLevelzRV=80
}
