//=============================================================================
// utb_BloodDrop.
//=============================================================================
class UTB_BloodDrop extends Blood2;

simulated function PostBeginPlay()
{
	Velocity = (Vector(Rotation) + VRand()) * (Rand(class'MoreBloodConfig'.default.SpurtLevelz));
	Velocity.x += Rand(class'MoreBloodConfig'.default.SpurtLevelx);
	Velocity.y += Rand(class'MoreBloodConfig'.default.SpurtLevelz);
	Texture = MultiSkins[Rand(8)];
	Drawscale = (FRand()*class'MoreBloodConfig'.default.BDDrawScale) + 0.0125;
	LifeSpan = (class'MoreBloodConfig'.default.BDLifeSpan / 2);
	if (Level.NetMode != NM_DedicatedServer)
	{
		SpawnDrop();
	}
	Super.PostBeginPlay();
}

simulated function SpawnDrop()
{
	local Actor A;

	A = spawn(class'UT_BloodDrop');
	A.RemoteRole = ROLE_SimulatedProxy;
}

defaultproperties
{
     bHighDetail=True
     Physics=PHYS_Falling
     bStatic=False
     LifeSpan=3.500000
     DrawType=DT_Sprite
     Style=STY_Masked
     Texture=Texture'Botpack.Blood.BD3'
     DrawScale=0.250000
     AmbientGlow=180
     MultiSkins(0)=Texture'Botpack.Blood.BD3'
     MultiSkins(1)=Texture'Botpack.Blood.BD4'
     MultiSkins(2)=Texture'Botpack.Blood.BD6'
     MultiSkins(3)=Texture'Botpack.Blood.BD9'
     MultiSkins(4)=Texture'Botpack.Blood.BD10'
     MultiSkins(5)=Texture'Botpack.Blood.BD3'
     MultiSkins(6)=Texture'Botpack.Blood.BD4'
     MultiSkins(7)=Texture'Botpack.Blood.BD6'
     bCollideWorld=True
     bBounce=True
     NetPriority=2.000000
}
