//=============================================================================
// utb_BloodDrop2.   Bouncy moving drops
//=============================================================================
class UTB_BloodDrop2 extends Blood2;

var int r, g;
var float prevloc;

simulated function PostBeginPlay()
{
	r = (FRand()*class'MoreBloodConfig'.default.SpurtLevelz);
	g = Rand(3) + 1;
	Velocity.x += (Rand(class'MoreBloodConfig'.default.SpurtLevelx) + g);
	Velocity.z += (Rand(class'MoreBloodConfig'.default.SpurtLevelz) + g);
	Velocity.y += r * g;
	Texture = MultiSkins[Rand(8)];
	Drawscale = (FRand()*class'MoreBloodConfig'.default.BDDrawScale) + 0.0125;
	LifeSpan = class'MoreBloodConfig'.default.BDLifeSpan;
	if (Level.NetMode != NM_DedicatedServer)
	{
		SpawnDrop();
	}
	Super.PostBeginPlay();
}

simulated function SpawnDrop()
{
	local Actor A;

	A = spawn(class'UT_BloodDrop');
	A.RemoteRole = ROLE_SimulatedProxy;
}

simulated function HitWall( vector HitNormal, actor Wall )
{
	if (Level.NetMode != NM_DedicatedServer)
	{
	  if ((prevloc != Self.Location.z) && (Velocity.z > -255.0))
		  {
			Velocity.z += r;
			r = r + g++;
			Velocity.z *= -1;
		  }
	  else
	    if ((prevloc != Self.Location.z) && (Velocity.z > -255.0))
	      {
		Velocity.z -= r++;
	      }
		  
	prevloc = Self.Location.z;
	}
}

defaultproperties
{
     bHighDetail=True
     Physics=PHYS_Falling
     bStatic=False
     LifeSpan=3.500000
     DrawType=DT_Sprite
     Style=STY_Masked
     Texture=Texture'Botpack.Blood.BD3'
     DrawScale=0.250000
     AmbientGlow=180
     MultiSkins(0)=Texture'Botpack.Blood.BD3'
     MultiSkins(1)=Texture'Botpack.Blood.BD4'
     MultiSkins(2)=Texture'Botpack.Blood.BD6'
     MultiSkins(3)=Texture'Botpack.Blood.BD9'
     MultiSkins(4)=Texture'Botpack.Blood.BD10'
     MultiSkins(5)=Texture'Botpack.Blood.BD3'
     MultiSkins(6)=Texture'Botpack.Blood.BD4'
     MultiSkins(7)=Texture'Botpack.Blood.BD6'
     bCollideWorld=True
     bBounce=True
     NetPriority=2.000000
}
