//=============================================================================
// utb_GBloodDrop2.
//=============================================================================
class UTB_GBloodDrop2 extends Blood2;

simulated function PostBeginPlay()
{
	Velocity = (Vector(Rotation) + VRand()) * (class'MoreBloodConfig'.default.SpurtLevelz * FRand());
	Velocity.z += (FRand()*class'MoreBloodConfig'.default.SpurtLevelz) + class'MoreBloodConfig'.default.SpurtLevelz;
	Velocity.z *= -1;
	Drawscale = ((FRand()*class'MoreBloodConfig'.default.BDDrawScale) / 5) + 0.00125;
	LifeSpan = class'MoreBloodConfig'.default.BDLifeSpan;
	if (Level.NetMode != NM_DedicatedServer)
	{
		SpawnDrop();
	}
	Super.PostBeginPlay();
}

simulated function SpawnDrop()
{
	local Actor A;

	A = spawn(class'UT_BloodDrop');
	A.RemoteRole = ROLE_SimulatedProxy;
}

simulated function HitWall( vector HitNormal, actor Wall )
{
	if (Level.NetMode != NM_DedicatedServer)
	{
		if (Rand(2) == 1)
		{
			Velocity.z += (class'MoreBloodConfig'.default.SpurtLevelz * 2);
			Velocity.x = 0;
			Velocity.y = 0;
		}
		else
		{
			Velocity.z += (class'MoreBloodConfig'.default.SpurtLevelz * 2);
			Velocity.x += (class'MoreBloodConfig'.default.SpurtLevelx * 2);
		}
		Velocity.z *= -1;
		if (Rand(16) == 1)
		{
		  if (Rand(2) == 1)
			{
			if (Drawscale < (class'MoreBloodConfig'.default.BDDrawScale / 5))
				Drawscale = Drawscale + (class'MoreBloodConfig'.default.BDDrawScale / 10);
			}
		  else
			{
			if (Drawscale > 0.0025)
				Drawscale = Drawscale - (class'MoreBloodConfig'.default.BDDrawScale / 10);
			}
		}
	}
}

defaultproperties
{
     bHighDetail=True
     Physics=PHYS_Falling
     bStatic=False
     LifeSpan=2.000000
     DrawType=DT_Sprite
     Style=STY_Masked
     Texture=Texture'BloodSGrn'
     DrawScale=0.0600000
     AmbientGlow=160
     bCollideWorld=True
     bBounce=True
     NetPriority=2.000000
}
